<html>
  <head> </head>
  <body>
    <script type="text/javascript" src="https://static.zdassets.com/zendesk_app_framework_sdk/2.0/zaf_sdk.min.js"></script>
    <script>
      ((document, global, undefined) => {
        // Initialise the Zendesk JavaScript API client
        var client = global.ZAFClient.init();
        console.log('====== background ========')
        console.log(client)
        var flexInstance;

        function registerInstances(location, instanceGuid) {
          if (location === 'top_bar') {
            flexInstance = client.instance(instanceGuid);
            flexPopover();
          }
        }

        function flexPopover() {
          flexInstance.on('pane.created', function() {
            client.metadata().then(function(metadata) {
              var defaultWidgetWidth = 330;
              var defaultWidgetHeight = 500;

              flexInstance.invoke('resize', {
                width: metadata.settings.widget_width || defaultWidgetWidth,
                height: metadata.settings.widget_height || defaultWidgetHeight,
              });
            });

            flexInstance.invoke('popover');
          });
        }

        client.get('instances').then(function(data) {
          Object.keys(data.instances).forEach(function(instanceGuid) {
            registerInstances(data.instances[instanceGuid].location, instanceGuid);
          });
        });

        client.on('instance.created', function(context) {
          registerInstances(context.location, context.instanceGuid);
        });

        client.on('ticket.app.activated', function(context) {
          flexInstance.trigger('ticket.activated', context);
        });

        client.on('ticket.app.deactivated', function() {
          flexInstance.trigger('ticket.deactivated');
        });

        client.on('click_to_dial', function(context) {
          flexInstance.trigger('click_to_dial', context);
        });
        client.on('send_sms_message', function(context) {
          flexInstance.trigger('send_sms_message', context);
        });        

        client.on('ticket.log', function({ ticketId, message, status }) {
          var commentData = { ticket: { comment: { public: 'false', body: message } } };

          return client.request({
            url: '/api/v2/tickets/' + ticketId + '.json',
            type: 'PUT',
            contentType: 'application/json',
            data: JSON.stringify(commentData),
          });
        });
      })(document, window);
    </script>
  </body>
</html>